IMPLEMENTATION MODULE Board;
(*  1990-2017 Ari.Tao  * 09.06.90 ~ 09.09.96
                     .
*)(*$S-,$T-,$Q+*)

(* Fr's TeDeum:
IMPORT AEI,AEB, SYSTEM, BIOX, Keys, Aux, Ev, VT,VN;
*)
FROM SYSTEM IMPORT ADR;
FROM   Keys IMPORT NUMOPERS, NONSCANS, ESCP,BACK,TABU,DELT,RETN,ENTR,
            F10,SF10,HOME,ARUP,LEFT,RITE,DOWN,INST,UNDO,HELP,CLFT,CRGT,CCLR;
IMPORT SX;

TYPE   CharSet = SET OF CHAR;

VAR    rshSyms,lshSyms,ctlSyms,altSyms, StaSy,StaSy0: SSS;

PROCEDURE KeySel (State,Code: CARDINAL): (*Token:*) CARDINAL;
 VAR   p: pTabType; ch: CHAR;  
 BEGIN IF (State MOD 4) # 0 THEN p := xP ELSE p := xp END;
       Code := Code DIV 256;           ch :=  p^[Code];
       IF (State MOD 32 = 16(*CapsLocked*)) &
          (CHR(Code) IN NUMOPERS) THEN ch := Hex (ch) END;
       IF (ALT IN BITSET (State)) THEN ch := Alt (ch) END;
       IF (CTL IN BITSET (State)) THEN ch := Ctl (ch) END;
       RETURN (ORD (CHAR (State)) *256 + ORD (ch)) END KeySel;

PROCEDURE NamSel (Entry: ARRAY OF CHAR): (*Token:*) CARDINAL;
 VAR   Pancake: CARDINAL;
 BEGIN Pancake := Identify (Entry);
       RETURN KeySel (Pancake MOD 256, Pancake); END NamSel;

PROCEDURE Key (ac: CHAR): CHAR;                (* Der 1. der Scan-Codes ! *)
 VAR  j, k: CARDINAL; Ch: CHAR; pt: pTabType;
 BEGIN         pt := xP;                       (* Erst in Shifteds suchen.*)
  FOR j := 1 TO 2 DO        k := 0;            (* Nr. 0 kann's nicht sein.*)
   WHILE k < TABLEN DO INC (k); Ch := pt^[k];
    IF (ac = Ch) OR (ac = Alt(Ch)) OR (ac = Ctl(Ch)) THEN RETURN CHR(k) END;
    END (*k*); pt := xp; END (*j*); RETURN 0c (*nixgefundn*); END Key;

PROCEDURE Ctl (ch: CHAR): CHAR;
 VAR   Ch: CHAR;
 (* Org.: 0: @` 2  1B: [{;Esc  1C: \|<  1D: ]}=Pgf  1E: ^~>6  1F: _Del?- *)
 BEGIN Ch := Cap (ch);
   IF (Ch >= 'A') & (Ch <= 'Z') THEN RETURN CHR (ORD (Ch) -40H) END;
  CASE ch OF '@','`',' ': RETURN 00c;                 (* & 0c, 2 wegg. *)
           | '[','{',';': RETURN 33c; (* = 1BH *)     (* & ESC sowieso.*)
           | '\','|','<': RETURN 34c; (* = 1CH *)
           | ']','}','=': RETURN 35c; (* = 1DH *)     (* PGF weggelasn.*)
           | '^','~','>': RETURN 36c; (* = 1EH *)     (* 6, weggelasn.*)
           | '_',DEL,'?': RETURN 37c; (* = 1FH *)     (* - weggelassen.*)
           ELSE RETURN ch END (*C*); END Ctl;

PROCEDURE Cap (ch: CHAR): CHAR;
    BEGIN CASE ch OF '': RETURN '' | '': RETURN '' | '': RETURN '';
                    ELSE  RETURN CAP (ch) END (*C*); END Cap;

PROCEDURE Alt (ch: CHAR): CHAR;
    BEGIN CASE ch OF '': RETURN '@' | '': RETURN '[' | '': RETURN ']';
                    |'': RETURN '\' | '': RETURN '{' | '': RETURN '}';
                    ELSE  RETURN ch END (*C*); END Alt;

PROCEDURE Hex (ch: CHAR): CHAR;
    BEGIN CASE ch OF '(': RETURN 'A' | '/': RETURN 'C' | '-': RETURN 'E';
                    |')': RETURN 'B' | '*': RETURN 'D' | '+': RETURN 'F';
                    ELSE  RETURN ch END (*C*); END Hex;

PROCEDURE  SetStatusSymbols  (rsh,lsh,ctl,alt: SSS);
 BEGIN rshSyms := rsh; lshSyms := lsh; ctlSyms := ctl; altSyms := alt;
                     StaSy := rsh+lsh+ctl+alt; StaSy0 := SSS {' '} + StaSy;
       END SetStatusSymbols;

CONST RSHSYMS = SSS {272c(*IDASH*), 276c(*REGIS*), 6c(*PTURN*)};
      LSHSYMS = SSS {371c(*UPDOT*), 255c(*SPAEX*), 1c(*ARRUP*)};
      CTLSYMS = SSS {370c(*EXPO0*), 336c(*LOGAD*), 5c(*CROSS*)};
      ALTSYMS = SSS {313c(*IEDGE*), 221c(*LIGAE*), 7c(*CARET*)};

CONST (*0               1               2               3                *)
  (*    0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF *)
  s1 = "  1234567890'  qwertzuiop+  asdfghjkl# ~yxcvbnm,.-          ";
  s2 = "          -   +                 <  ()/*7894561230.      1234567890";
  S1 = '  !" $%&/()=?`  QWERTZUIOP*  ASDFGHJKL^ |YXCVBNM;:_          ';
  S2 = '                                >                       ';
VAR   s0,S0,L0: TabType; k: CARDINAL;

PROCEDURE Init;
 BEGIN SetStatusSymbols (RSHSYMS, LSHSYMS, CTLSYMS, ALTSYMS);
   SX.Add (s1,s2, s0); SX.Add (S1,S2, S0); xp := ADR (s0); xP := ADR (S0);
   s0[00H] := NUL; s0[01H] := ESC; s0[0EH] := BAC; s0[0FH] := TAB;
   s0[1CH] := RET; s0[53H] := DEL;                 s0[72H] := RET;
   s0[4BH] := LFT; s0[4DH] := RGT; s0[48H] := AUP; s0[50H] := DWN;
   s0[73H] := LFT; s0[74H] := RGT; s0[77H] := cCL; s0[83H] := CHR (26);
   FOR k:= 0 TO TABLEN DO IF s0[k] = ' ' THEN s0[k] := CHAR (k+66H) END END;
   FOR k:= 0 TO TABLEN DO IF CHR (k) IN NONSCANS THEN  s0[k] := ' ' END END;
   FOR k:=17 TO 27 DO s0[67H+k] := CHR (k) END;   s0[81H] := CHR (16);
   FOR k:= 0 TO TABLEN DO IF S0[k] = ' ' THEN S0[k] := CHAR (k+8DH) END END;
   FOR k:= 0 TO TABLEN DO IF CHR (k) IN NONSCANS THEN  S0[k] := ' ' END END;
   FOR k:= 5 TO 15 DO S0[73H+k] := CHR (k) END;      S0[83H] := CHR (235);
   S0[01H] := sESC; S0[04H] :=  PGF; S0[1CH] := sRET; S0[3BH] := 354c;
   S0[63H] := sBRA; S0[64H] := sKET; S0[65H] := sDIV; S0[66H] := sMUL;
   S0[67H] := 367c; S0[68H] := 370c; S0[69H] := 371c; S0[6AH] := 364c;
   S0[6BH] := 365c; S0[6CH] := 366c; S0[6DH] := 361c; S0[6EH] := 362c;
   S0[6FH] := 363c; S0[70H] := 360c; S0[71H] := sPNT; S0[72H] := sENT;
   S0[73H] := scLF; S0[74H] := scRG; S0[77H] := scCL; S0[50H] := sDWN;
   S0[00H] :=  NUL; S0[TABLEN] :=  NUL; S0[TABLEN1] := 0c;  (* C-Abschlu.*)
   s0[39H] :=  ' '; s0[TABLEN] :=  NUL; s0[TABLEN1] := 0c;  (* C-Abschlu.*)
   pX := ADR (L0); SX.Asg (L0, s0);  L0[4AH] :=  'E'; L0[4EH] :=  'F';
   L0[63H] :=  'A'; L0[64H] :=  'B'; L0[65H] :=  'C'; L0[66H] :=  'D';
   FOR k := 0 TO TABLEN DO L0[k] := Cap (L0[k]) END;
   END Init;

CONST CIPHERS = CharSet {'0'..'9'};
      NUMBLOC = CharSet {'(',')','/','*','-','+','.'} + CIPHERS;
      TOPROW0 = CharSet {'!','"',PGF,'$','%','&','/','(',')','=','?','`'};
      TOPROW  = CharSet {'',"'"} + TOPROW0 + CIPHERS;
      UPPERS  = CharSet {'^','\','*','{','}','>',';',':','_','|'} + TOPROW0;

                                                  (* Der Key-Name-Parser: *)
PROCEDURE Identify (VAR N(*ame*): ARRAY OF CHAR): (*Scan&State:*) CARDINAL;
 VAR   o,a,z,l: CARDINAL; k: CHAR; StateS: BITSET;
       Shifted, Contred, Altered: BOOLEAN;
 BEGIN o := SX.Len (N);   IF (o = 0) THEN RETURN 0 END; DEC (o);    k := 0c;
   WHILE  (N[o] = ' ')     & (o > 0) DO DEC (o) END;    a := o;
   WHILE ~(N[a] IN StaSy0) & (a > 0) DO DEC (a) END;    l := o -a; z := a;
   WHILE  (N[z] IN StaSy)  & (z > 0) DO DEC (z) END;    StateS := {};
   WHILE  (z # a) DO INC (z);
        IF N[z] IN rshSyms THEN INCL (StateS, RSH);
     ELSIF N[z] IN lshSyms THEN INCL (StateS, LSH);
     ELSIF N[z] IN ctlSyms THEN INCL (StateS, CTL);
     ELSIF N[z] IN altSyms THEN INCL (StateS, ALT); END; END (*z*);
   Shifted := (RSH IN StateS) OR (LSH IN StateS);
   Contred := (CTL IN StateS);
   Altered := (ALT IN StateS);
   CASE l OF
   | 1: IF ~(Altered & (N[o] IN TOPROW)) THEN
             CASE N[o] OF 1C: k := ARUP; | 2C: k := DOWN;
             | 3C: IF Contred THEN k := CRGT ELSE k := RITE END;
             | 4C: IF Contred THEN k := CLFT ELSE k := LEFT END;
             ELSE k := Key (N[o]) END (*C*);
        ELSE  z := 78H;
          WHILE (N[o] # xp^[z]) & (N[o] # xP^[z]) & (z < 84H) DO INC(z) END;
          IF (z #  84H) THEN k := CHAR (z) END; END (*E*);
        IF (N[o] IN UPPERS) THEN INCL (StateS, LSH) END;
   | 2: CASE N[o-1] OF  (* 'B': IF (Cap (N[o]) = 'S') THEN k := BACK END; *)
        |'F': IF (N[o] IN CIPHERS) & (N[o] # '0') THEN
                IF Shifted THEN k := CHAR (53H + ORD (N[o]) -30H);
                ELSE            k := CHAR (3AH + ORD (N[o]) -30H); END; END;
        |'n','N': IF (N[o] IN NUMBLOC) THEN   z := 63H;
                     WHILE (N[o] # xp^[z]) & (z <  72H) DO INC (z) END;
                     IF (z # 72H) THEN k := CHAR (z);
                     ELSE IF N[o] = '-' THEN k := CHAR (4AH);
                       ELSIF N[o] = '+' THEN k := CHAR (4BH); END; END; END;
        ELSE (*nixtun*) END (*C*);
   | 3: CASE Cap (N[o]) OF
        |'0': IF (N[o-1] = '1') & (N[o-2] = 'F') THEN
                IF Shifted THEN k := SF10 ELSE k := F10 END; END (*I*);
        |'B': IF (Cap (N[o-1]) = 'A') & (N[o-2] = 'T') THEN k := TABU END;
        |'C': IF (Cap (N[o-1]) = 'S') & (N[o-2] = 'E') THEN k := ESCP END;
        |'K': IF (Cap (N[o-1]) = 'A') & (N[o-2] = 'B') THEN k := BACK END;
        |'L': IF (Cap (N[o-1]) = 'E') & (N[o-2] = 'D') THEN k := DELT END;
        |'O': IF (N[o-1] = 'D') & (Cap (N[o-2]) = 'N') THEN k := UNDO END;
        |'P': IF (Cap (N[o-1]) = 'L') & (N[o-2] = 'H') THEN k := HELP END;
        |'R': IF (Cap (N[o-1]) = 'L') & (N[o-2] = 'C') THEN
                IF Contred THEN k := CCLR ELSE k := HOME END; END (*I*);
        |'S': IF (Cap (N[o-1]) = 'N') & (N[o-2] = 'I') THEN k := INST END;
        |'T': IF (Cap (N[o-1]) = 'N') & (N[o-2] = 'E') THEN k := ENTR END;
              IF (Cap (N[o-1]) = 'E') & (N[o-2] = 'R') THEN k := RETN END;
        ELSE (*nixtun*) END (*C*);
   ELSE (*nixtun*) END (*C*);
   RETURN (CARDINAL (StateS) + 256 * ORD (k));
 END Identify;

(**)
BEGIN Init END Board .
*)

MODULE TESTandDEMO;  (* Scan- & ASCII-Codes (hiB & loB) der Tasten in HEX.*)
FROM  SYSTEM IMPORT ADR, ADDRESS, WORD;
FROM   Aux   IMPORT Incl;
FROM   VT    IMPORT wt, wT, Clr, Cur0, Ln, Sp;
FROM   Keys  IMPORT NONSCANS, NUMBLOCK, CUARROWS, SPAC, ESCP,
                    BACK,TABU,DELT, RETN,ENTR, HELP,UNDO,INST,HOME,CCLR;
FROM   Ev    IMPORT Pause;
IMPORT AEB, SX, VN, BIOX, Init, ESC, TABLEN1, CharSet,
       RSH,LSH,CTL,ALT,LCK, xp,xP,pX, KeySel, Key, Cap, Alt, pTabType;

CONST  COPYRITE =  "[2][             by THEODOR TASTE| ";
       FACHOICE =     "|  BOARD.PRG | ][Tafeln|  Test  | Ende ]";
       HELPPOP0 = "[1][| Hilfe:  li. Click: Leerzeile |";
       HELPPOP1 =      "         re. Click: Hilfe-Pop |";
       HELPPOP2 =      "      2Click re.: 1v2-spaltig |";
       HELPPOP3 =      "      Beide M.T.: Haupt-Menue ][    OK    ]";

CONST (* State-Symbols: *)
       DSH = 272c; EDG = 313c; UP0 = 370c; UPD = 371c; UPN = 374c;

PROCEDURE Moff; BEGIN AEB.GrafMouseDef (256) END Moff;
PROCEDURE ClrS; BEGIN Moff; Cur0; Clr END ClrS;
PROCEDURE Sps (n: CARDINAL); BEGIN WHILE n>0 DO Sp; DEC (n) END END Sps;

VAR zwiSp:  BOOLEAN;                  (* Umschalter 1/2-spaltig.*)
    count:  CARDINAL;                 (* ScanTest-Zeilen-Zhler.*)
    KeyTab: BIOX.KeyTable;
   pKeyTab: BIOX.KeyTblPtr;
    pT,pt:  pTabType;                 (* -> KeyTab.shift, .unsh.*)
    HelPop,
    PopUp:  ARRAY [0..200] OF CHAR;

PROCEDURE Help; BEGIN IF 1 = AEB.FormAlert (1, HelPop) THEN END END Help;

PROCEDURE TableTest (TabAdr: ADDRESS);
 VAR   p:  pTabType;    K,k: CARDINAL;
 BEGIN p := TabAdr; Ln; K := 32; k := 0; CountLine; Ln;
   REPEAT IF K # TABLEN1 THEN Ln; Sp; Sp; Sp END;
       WHILE k < K DO BIOX.RawCO (p^[k]); Sp; INC (k) END;
       INC ( K, 32); IF K > TABLEN1 THEN K := TABLEN1 END;
       UNTIL k = TABLEN1; Ln; END TableTest;

PROCEDURE CountLine;                    (* Erzeugt 0123456789ABCDEF0123...*)
 VAR   ch: CHAR; c,k: CARDINAL;
 BEGIN Sp; Sp; Sp; k := 0;
    WHILE (32 > k) DO c := k MOD 16; INC (k);
       IF   c < 10 THEN    ch := CHR (30H +c);
       ELSE c := c MOD 10; ch := CHR (41H +c) END;
       wt (ch); wt (' '); END (*k*); END CountLine;

PROCEDURE Header;
 PROCEDURE Hl; BEGIN wT ("   Key State Scan Ascii Ch Token ** ") END Hl;
 BEGIN Ln; Hl; IF zwiSp THEN Sp; Sp; Hl END; Ln; Ln; count := 0; END Header;

PROCEDURE WriteName (Scan: CHAR; Shift, Alter: BOOLEAN); (* KeyWord-Table.*)
 VAR   ch: CHAR;        (* Im wesentl. inverse Proc. zum Key-Name-Parser; *)
 BEGIN CASE Scan OF     (*  spter von xp befreien & nach Keys auslagern? *)
       | CHR(3BH)..CHR(43H): wT ('  F'); wt (CHR(ORD(Scan)-10));
       | CHR(54H)..CHR(5CH): wT ('  F'); wt (CHR(ORD(Scan)-35));
       | CHR(44H), CHR(5DH): wT (' F10');                   (* ALTERNATs: *)
       | CHR(78H)..CHR(83H): WriteName (CHR(ORD(Scan)-76H), Shift, Alter);
       | SPAC: wT (' BAR');
       | ESCP: wT (' Esc');
       | BACK: wT (' Bac');
       | TABU: wT (' Tab');
       | RETN: wT (' Ret');
       | DELT: wT (' Del');
       | ENTR: wT (' Ent');
       | INST: wT (' Ins');
       | HELP: wT (' Hlp');
       | UNDO: wT (' nDO');
       | HOME, CCLR: wT (' Clr');
       ELSE Sp; Sp;
          IF Scan IN NUMBLOCK THEN wt ('N') ELSE Sp END;
          IF Shift & ~(Scan IN NUMBLOCK) & ~(Scan IN CUARROWS) THEN
               ch := xP^[ORD(Scan)];
          ELSE ch := xp^[ORD(Scan)] END;
          IF Alter THEN ch := Alt (ch) END;
          ch := Cap (ch);              (* statt 'Write' (wg. der Pfeile): *)
          BIOX.RawCO(ch) END (*C*); END WriteName;

VAR  State, Scan, Ascii, Token: INTEGER;

PROCEDURE WriteOne;
 VAR   ch: CHAR; StateS: BITSET;        (* Global: State,Scan,Ascii,Token.*)
 BEGIN INC (count);
       IF (CHAR (Scan) IN NONSCANS) THEN EmptyLine; RETURN END;
       ch := CHR (Ascii);     StateS := BITSET (State); Sp; Sp;
       WriteName (CHR(Scan), (State MOD 4) # 0, ALT IN StateS); Sp;
       IF (LCK IN StateS) THEN wt (UPN) ELSE Sp END;
       IF (ALT IN StateS) THEN wt (EDG) ELSE Sp END;
       IF (CTL IN StateS) THEN wt (UP0) ELSE Sp END;
       IF (LSH IN StateS) THEN wt (UPD) ELSE Sp END;
       IF (RSH IN StateS) THEN wt (DSH) ELSE Sp END;
       VN.wHexW (Scan,  5); Sp;
       VN.wHexW (Ascii, 5); Sp; Sp;
       BIOX.RawCO (ch); Sp;
       VN.wHexW (Token, 5); Sp; Sp;
       ch :=CHAR(Token);
       BIOX.RawCO (ch); Sp; Sp; Sp;
       IF ~zwiSp OR ((count MOD 2) = 0) THEN Ln END; END WriteOne;

PROCEDURE  EmptyLine;
 BEGIN IF ~zwiSp OR ((count MOD 2) = 0) THEN Ln ELSE Sps (38) END;
       END EmptyLine;

PROCEDURE GetTabs;                          (* Damit's die aktuellen sind.*)
 BEGIN pt := ADR (pKeyTab^.pUnshs^);
       pT := ADR (pKeyTab^.pShifts^); END GetTabs;

PROCEDURE Asc (n: CARDINAL): CARDINAL;
 BEGIN IF (State MOD 4) = 0 THEN RETURN ORD (pt^[n]);
                            ELSE RETURN ORD (pT^[n]) END; END Asc;

PROCEDURE WriteTwo ((*States:*) Sj,Sk, (*Scans:*) j,k: INTEGER);
 VAR Code: INTEGER;                   (* Global: State, Scan,Ascii, Token.*)
 BEGIN Scan := j; State := Sj; Ascii := Asc (j);
       Code := j *256 + Ascii; Token := KeySel (State, Code);
       WriteOne;
       Scan := k; State := Sk; Ascii := Asc (k);
       Code := k *256 + Ascii; Token := KeySel (State, Code);
       WriteOne; END WriteTwo;

PROCEDURE WriteFuncs;
 VAR   j,k,i: INTEGER;
 BEGIN GetTabs; zwiSp := TRUE; Header; j := 3BH; k := 54H; i := 0;
    WHILE (i < 10) DO  WriteTwo (0, 2, j, k);
      INC (i); INC (j); INC (k); END (*i*); END WriteFuncs;

PROCEDURE WriteNumbs;
 VAR   j,k,i: INTEGER;
 BEGIN GetTabs; zwiSp := TRUE; Header; j := 63H; k := 63H; i := 0;
    WHILE (i < 16) DO  WriteTwo (0, 2, j, k);
      INC (i); INC (j); INC (k); END (*i*);     Ln;
    WriteTwo (0, 2, 4AH, 4AH);                                   (* N-,N+ *)
    WriteTwo (0, 2, 4EH, 4EH); END WriteNumbs;

PROCEDURE WriteUmlts;
 VAR S: INTEGER;
 BEGIN GetTabs; zwiSp := TRUE; Header;
     S :=0; WHILE (S < 16) DO WriteTwo (S, S+2, 1AH, 1AH); INC(S,4) END; Ln;
     S :=0; WHILE (S < 16) DO WriteTwo (S, S+2, 27H, 27H); INC(S,4) END; Ln;
     S :=0; WHILE (S < 16) DO WriteTwo (S, S+2, 28H, 28H); INC(S,4) END; Ln;
     END  WriteUmlts;

PROCEDURE  WriteCurBs;
 BEGIN GetTabs; zwiSp := TRUE; Header;
       WriteTwo (0, 2, 48H, 48H); WriteTwo (4, 6, 48H, 48H);       (* AUP *)
       WriteTwo (0, 2, 50H, 50H); WriteTwo (4, 6, 50H, 50H);       (* DWN *)
       WriteTwo (0, 2, 4BH, 4BH); WriteTwo (4, 6, 73H, 73H);       (* LFT *)
       WriteTwo (0, 2, 4DH, 4DH); WriteTwo (4, 6, 74H, 74H);       (* RGT *)
       WriteTwo (0, 2, 47H, 47H); WriteTwo (4, 6, 77H, 77H);       (* CLR *)
       WriteTwo (0, 2, 52H, 52H);                                  (* INS *)
       WriteTwo (0, 2, 61H, 61H);                                  (* NDO *)
       WriteTwo (0, 2, 62H, 62H);                                  (* HLP *)
       END WriteCurBs;

PROCEDURE WriteSigns;
 VAR   j,k,i: INTEGER;
 BEGIN GetTabs; zwiSp := TRUE; Header; j :=  2H; k := 78H; i := 0;
    WHILE (i < 12) DO  WriteTwo (2,10, j, k);
      INC (i); INC (j); INC (k); END (*i*); END WriteSigns;

PROCEDURE WriteCtrls;
 VAR   ch: CHAR; Code: INTEGER;         (* Global: State,Scan,Ascii,Token.*)
 BEGIN zwiSp := TRUE; Header; ch := 0c;
    WHILE (ch < 40c) DO Scan := ORD (Key (ch));
       State := 2; Ascii := ORD (xP^[Scan]); Code := Scan *256 + Ascii;
       Token := KeySel (State, Code);        WriteOne;
       State := 6; Ascii := ORD (ch);        Code := Scan *256 + Ascii;
       Token := KeySel (State, Code);        WriteOne;
       INC(ch); IF ch = 24c THEN Pause; ClrS END; END(*ch*); END WriteCtrls;

PROCEDURE WriteScans;
 VAR   ch: CHAR; Code: INTEGER;         (* Global: State,Scan,Ascii,Token.*)
 BEGIN GetTabs; zwiSp := TRUE; Header; ch := 0c;
    WHILE (ch < 204c) DO  Scan := ORD (ch); Code := Scan * 256;
       IF    (CHR (53H) < ch) & (ch < CHR (60H)) THEN State := 2;
       ELSIF (CHR (72H) < ch) & (ch < CHR (78H)) THEN State := 4;
       ELSIF (CHR (77H) < ch) & (ch < CHR (85H)) THEN State := 8;
       ELSE  State := 0 END;
       Ascii := Asc (ORD (ch));
       Token := KeySel (State, Code);
       WriteOne;
       INC(ch); IF ch = 50c THEN Pause; ClrS END;
                IF ch =130c THEN Pause; ClrS END; END(*ch*); END WriteScans;

PROCEDURE AllTables;
 BEGIN
    wT ("  Normal     "); TableTest (pKeyTab^.pUnshs);  Ln;
    wT ("  Shift      "); TableTest (pKeyTab^.pShifts); Ln;
    wT ("  CapsLock   "); TableTest (pKeyTab^.pCapsls); Pause; ClrS; Ln;
    wT ("  Extended   "); TableTest (xp); Ln;
    wT ("  Ext.Shift  "); TableTest (xP); Ln;
    wT ("  Ext.C.Lock "); TableTest (pX); Pause; ClrS; Ln;
    wT ("  ScanCode   "); WriteScans; Pause; ClrS; Ln;
    wT ("  FuncKeys   "); WriteFuncs; Pause; ClrS; Ln;
    wT ("  Signs      "); WriteSigns; Pause; ClrS; Ln;
    wT ("  NumBlock   "); WriteNumbs; Pause; ClrS; Ln;
    wT ("  CursorBlock"); WriteCurBs; Pause; ClrS; Ln;
    wT ("  Umlauts    "); WriteUmlts; Pause; ClrS; Ln;
    wT ("  Controls   "); WriteCtrls; Pause; Ln; END AllTables;

PROCEDURE ScanTest;
 VAR   Eve: INTEGER; Es: AEB.EvSensor;  (* Global: State,Scan,Ascii,Token,*)
 BEGIN Help; Header;                    (*         zwiSp, count.          *)
       AEB.Ae (Es, 1+2, 256+2, 3, 0, 0,0,0,0,0, 0,0,0,0,0, 0,0);
  LOOP Eve := INTEGER (AEB.EventMulti (Es));
   WITH Es.Ret DO WITH MoR DO State := INTEGER (KeySt);
         IF (LCK IN BIOX.KBShiftS ()) THEN Incl (State, LCK) END;
    CASE Eve OF 1: Scan  := CARDINAL(KeyC) DIV 256;
                   Ascii := CARDINAL(KeyC) MOD 256;
                   Token := KeySel (State, KeyC);    WriteOne;
    | 2: IF (Clix = 2) & (ButSt = {1}) THEN zwiSp := ~zwiSp; Header;
         ELSE CASE INTEGER(ButSt) OF 3: EXIT; | 2: Help;
              | 1: WHILE (Clix >0) DO INC (count); EmptyLine; DEC(Clix) END;
              ELSE (*gibtsnich*) END END (*C,E*);
    ELSE (*gibtsnich*) END; END END END (*W,W,L*); END ScanTest;

BEGIN (*I*) zwiSp := TRUE; Init;
   WITH KeyTab DO pUnshs :=NIL; pShifts :=NIL; pCapsls :=NIL;  (* Abfrage.*)
       pKeyTab := BIOX.KeyTblSetA (pUnshs, pShifts, pCapsls) END;
   SX.Add (HELPPOP0,HELPPOP1, HelPop);
   SX.Add (HelPop,  HELPPOP2, HelPop);
   SX.Add (HelPop,  HELPPOP3, HelPop);
   SX.Add (COPYRITE,FACHOICE, PopUp);
   AEB.WindSem (AEB.OWN);
   LOOP ClrS; Ln;
        CASE AEB.FormAlert(2,PopUp) OF 1: AllTables | 2: ScanTest | 3: EXIT;
        ELSE (*gibtsnich*) END END (*C,L*);
   AEB.DeskRefresh;
   AEB.WindSem (AEB.CLR);
   END (*M*) TESTandDEMO;

END Board .
